# Autogenerated wrapper script for libcap_jll for aarch64-linux-gnu
export libcap, capability_h

## Global variables
PATH = ""
LIBPATH = ""
LIBPATH_env = "LD_LIBRARY_PATH"

# Relative path to `libcap`
const libcap_splitpath = ["lib64", "libcap.so"]

# This will be filled out by __init__() for all products, as it must be done at runtime
libcap_path = ""

# libcap-specific global declaration
# This will be filled out by __init__()
libcap_handle = C_NULL

# This must be `const` so that we can use it with `ccall()`
const libcap = "libcap.so.2"


# Relative path to `capability_h`
const capability_h_splitpath = ["include", "sys", "capability.h"]

# This will be filled out by __init__() for all products, as it must be done at runtime
capability_h_path = ""

# capability_h-specific global declaration
# This will be filled out by __init__()
capability_h = ""


"""
Open all libraries
"""
function __init__()
    global prefix = abspath(joinpath(@__DIR__, ".."))

    # Initialize PATH and LIBPATH environment variable listings
    global PATH_list, LIBPATH_list
    global libcap_path = abspath(joinpath(artifact"libcap", libcap_splitpath...))

    # Manually `dlopen()` this right now so that future invocations
    # of `ccall` with its `SONAME` will find this path immediately.
    global libcap_handle = dlopen(libcap_path)
    push!(LIBPATH_list, dirname(libcap_path))

    global capability_h_path = abspath(joinpath(artifact"libcap", capability_h_splitpath...))

    global capability_h = capability_h_path
    # Filter out duplicate and empty entries in our PATH and LIBPATH entries
    filter!(!isempty, unique!(PATH_list))
    filter!(!isempty, unique!(LIBPATH_list))
    global PATH = join(PATH_list, ':')
    global LIBPATH = join(LIBPATH_list, ':')

    # Add each element of LIBPATH to our DL_LOAD_PATH (necessary on platforms
    # that don't honor our "already opened" trick)
    #for lp in LIBPATH_list
    #    push!(DL_LOAD_PATH, lp)
    #end
end  # __init__()

